class Actor {
  PImage image;
  PVector size;
  PVector position;
  PVector velocity;
  String tag;
  String popupText;
  boolean opened = false;
  boolean player = false;

  Actor(String filename, PVector _size, PVector _position) {
    image = loadImage(filename);
    tag = filename;
    size = _size;
    position = _position;
    velocity = new PVector(0,0);
    popupText = "";
  }

  void update() {
    position.add(velocity);
  }

  void draw() {
    pushMatrix();
    translate(position.x, position.y);
    image(image, 0, 0, size.x, size.y);
    textFont(helvetica, 12);
    text(popupText, 0, 0);
    popMatrix();
  }

  void switchSprite(String filename) {
    image = loadImage(filename);
  }

  void setPopupText(String text) {
    popupText = text;
  }

  boolean collidesWith(Actor otherActor){
    boolean collides = false;
    
    float myMinX = position.x;
    float myMaxX = position.x + size.x;
    float myMinY = position.y;
    float myMaxY = position.y + size.y;

    float theirMinX = otherActor.position.x;
    float theirMaxX = otherActor.position.x + otherActor.size.x;
    float theirMinY = otherActor.position.y;
    float theirMaxY = otherActor.position.y + otherActor.size.y;
    
    if(  myMinX > theirMaxX ||
         myMaxX < theirMinX ||
         myMinY > theirMaxY ||
         myMaxY < theirMinY ) {
       collides = false;  
     } else {
       collides = true;
     }

    return collides;
  }
}
